<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/Formatters/SXR.py.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/Formatters/SXR.py</title>
<link href="../../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../../Scopes/Synopsis.html" >Global Package</a></span>
<span class="normal"><a href="../../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/Formatters/SXR.py</b><pre class="sxr"><a id="line1"></a><span class="lineno">  1</span><span class="line"><span class="py-comment">#</span></span>
<a id="line2"></a><span class="lineno">  2</span><span class="line"><span class="py-comment"># Copyright (C) 2004 Stefan Seefeld</span></span>
<a id="line3"></a><span class="lineno">  3</span><span class="line"><span class="py-comment"># All rights reserved.</span></span>
<a id="line4"></a><span class="lineno">  4</span><span class="line"><span class="py-comment"># Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line5"></a><span class="lineno">  5</span><span class="line"><span class="py-comment"># see the file COPYING for details.</span></span>
<a id="line6"></a><span class="lineno">  6</span><span class="line"><span class="py-comment">#</span></span>
<a id="line7"></a><span class="lineno">  7</span>
<a id="line8"></a><span class="lineno">  8</span><span class="line"><span class="py-string">&quot;&quot;&quot;The SXR Facade around the HTML Formatter &quot;&quot;&quot;</span></span>
<a id="line9"></a><span class="lineno">  9</span>
<a id="line10"></a><span class="lineno"> 10</span><span class="line"><span class="py-keyword">from</span> Synopsis <span class="py-keyword">import</span> config</span>
<a id="line11"></a><span class="lineno"> 11</span><span class="line"><span class="py-keyword">from</span> Synopsis <span class="py-keyword">import</span> IR</span>
<a id="line12"></a><span class="lineno"> 12</span><span class="line"><span class="py-keyword">from</span> Synopsis.Processor <span class="py-keyword">import</span> *</span>
<a id="line13"></a><span class="lineno"> 13</span><span class="line"><span class="py-keyword">import</span> HTML</span>
<a id="line14"></a><span class="lineno"> 14</span><span class="line"><span class="py-keyword">from</span> HTML.View <span class="py-keyword">import</span> View, Template</span>
<a id="line15"></a><span class="lineno"> 15</span><span class="line"><span class="py-keyword">from</span> HTML.Views <span class="py-keyword">import</span> Directory, Source, RawFile</span>
<a id="line16"></a><span class="lineno"> 16</span><span class="line"><span class="py-keyword">import</span> os, os.path</span>
<a id="line17"></a><span class="lineno"> 17</span><span class="line"><span class="py-keyword">from</span> shutil <span class="py-keyword">import</span> copyfile</span>
<a id="line18"></a><span class="lineno"> 18</span>
<a id="line19"></a><span class="lineno"> 19</span><span class="line"><span class="py-keyword">class</span> <a href="../../../Scopes/Synopsis/Formatters/SXR/SXRIndex.html">SXRIndex</a>(View):</span>
<a id="line20"></a><span class="lineno"> 20</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Top level Index View. This is the starting point for the SXR browser.&quot;&quot;&quot;</span></span>
<a id="line21"></a><span class="lineno"> 21</span>
<a id="line22"></a><span class="lineno"> 22</span><span class="line">    sxr_cgi = Parameter(<span class="py-string">'sxr.cgi'</span>, <span class="py-string">'URL to use for sxr.cgi script'</span>)</span>
<a id="line23"></a><span class="lineno"> 23</span>
<a id="line24"></a><span class="lineno"> 24</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/SXR/SXRIndex.html#filename">filename</a>(self):</span>
<a id="line25"></a><span class="lineno"> 25</span>
<a id="line26"></a><span class="lineno"> 26</span><span class="line">        <span class="py-keyword">return</span> self.directory_layout.index()</span>
<a id="line27"></a><span class="lineno"> 27</span>
<a id="line28"></a><span class="lineno"> 28</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/SXR/SXRIndex.html#title">title</a>(self):</span>
<a id="line29"></a><span class="lineno"> 29</span>
<a id="line30"></a><span class="lineno"> 30</span><span class="line">        <span class="py-keyword">return</span> <span class="py-string">'Index'</span></span>
<a id="line31"></a><span class="lineno"> 31</span>
<a id="line32"></a><span class="lineno"> 32</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/SXR/SXRIndex.html#root">root</a>(self):</span>
<a id="line33"></a><span class="lineno"> 33</span>
<a id="line34"></a><span class="lineno"> 34</span><span class="line">        <span class="py-keyword">return</span> self.filename(), self.title()</span>
<a id="line35"></a><span class="lineno"> 35</span>
<a id="line36"></a><span class="lineno"> 36</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/SXR/SXRIndex.html#process">process</a>(self):</span>
<a id="line37"></a><span class="lineno"> 37</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Recursively visit each directory below the base path given in the</span></span>
<a id="line38"></a><span class="lineno"> 38</span><span class="line"><span class="py-string">        config.&quot;&quot;&quot;</span></span>
<a id="line39"></a><span class="lineno"> 39</span>
<a id="line40"></a><span class="lineno"> 40</span><span class="line">        self.start_file()</span>
<a id="line41"></a><span class="lineno"> 41</span>
<a id="line42"></a><span class="lineno"> 42</span><span class="line">        self.write(<span class="py-string">&quot;&quot;&quot;</span></span>
<a id="line43"></a><span class="lineno"> 43</span><span class="line"><span class="py-string">&lt;table class=&quot;form&quot;&gt;</span></span>
<a id="line44"></a><span class="lineno"> 44</span><span class="line"><span class="py-string">  &lt;tr&gt;</span></span>
<a id="line45"></a><span class="lineno"> 45</span><span class="line"><span class="py-string">    &lt;td&gt;Click here to start browsing at the root of the directory tree:&lt;/td&gt;</span></span>
<a id="line46"></a><span class="lineno"> 46</span><span class="line"><span class="py-string">    &lt;td&gt;</span></span>
<a id="line47"></a><span class="lineno"> 47</span><span class="line"><span class="py-string">      &lt;a href=&quot;dir.html&quot;&gt;/&lt;/a&gt;</span></span>
<a id="line48"></a><span class="lineno"> 48</span><span class="line"><span class="py-string">    &lt;/td&gt;</span></span>
<a id="line49"></a><span class="lineno"> 49</span><span class="line"><span class="py-string">  &lt;/tr&gt;</span></span>
<a id="line50"></a><span class="lineno"> 50</span><span class="line"><span class="py-string">  &lt;tr&gt;</span></span>
<a id="line51"></a><span class="lineno"> 51</span><span class="line"><span class="py-string">    &lt;td&gt;Enter a file name to search:&lt;/td&gt;</span></span>
<a id="line52"></a><span class="lineno"> 52</span><span class="line"><span class="py-string">    &lt;td&gt;</span></span>
<a id="line53"></a><span class="lineno"> 53</span><span class="line"><span class="py-string">      &lt;form method=&quot;get&quot; action=&quot;%(script)s/file&quot;&gt;</span></span>
<a id="line54"></a><span class="lineno"> 54</span><span class="line"><span class="py-string">        &lt;input type=&quot;text&quot; name=&quot;string&quot; value=&quot;&quot; size=&quot;15&quot;/&gt;</span></span>
<a id="line55"></a><span class="lineno"> 55</span><span class="line"><span class="py-string">        &lt;input type=&quot;submit&quot; value=&quot;Find&quot;/&gt;</span></span>
<a id="line56"></a><span class="lineno"> 56</span><span class="line"><span class="py-string">      &lt;/form&gt;</span></span>
<a id="line57"></a><span class="lineno"> 57</span><span class="line"><span class="py-string">    &lt;/td&gt;</span></span>
<a id="line58"></a><span class="lineno"> 58</span><span class="line"><span class="py-string">  &lt;/tr&gt;</span></span>
<a id="line59"></a><span class="lineno"> 59</span><span class="line"><span class="py-string">  &lt;tr&gt;</span></span>
<a id="line60"></a><span class="lineno"> 60</span><span class="line"><span class="py-string">    &lt;td&gt;Enter a variable, type, or function name to search:&lt;/td&gt;</span></span>
<a id="line61"></a><span class="lineno"> 61</span><span class="line"><span class="py-string">    &lt;td&gt;</span></span>
<a id="line62"></a><span class="lineno"> 62</span><span class="line"><span class="py-string">      &lt;form method=&quot;get&quot; action=&quot;%(script)s/ident&quot;&gt;</span></span>
<a id="line63"></a><span class="lineno"> 63</span><span class="line"><span class="py-string">        &lt;input type=&quot;text&quot; name=&quot;string&quot; value=&quot;&quot; size=&quot;15&quot;/&gt;</span></span>
<a id="line64"></a><span class="lineno"> 64</span><span class="line"><span class="py-string">        &lt;input type=&quot;submit&quot; value=&quot;Find&quot;/&gt;</span></span>
<a id="line65"></a><span class="lineno"> 65</span><span class="line"><span class="py-string">      &lt;/form&gt;</span></span>
<a id="line66"></a><span class="lineno"> 66</span><span class="line"><span class="py-string">    &lt;/td&gt;</span></span>
<a id="line67"></a><span class="lineno"> 67</span><span class="line"><span class="py-string">  &lt;/tr&gt;</span></span>
<a id="line68"></a><span class="lineno"> 68</span><span class="line"><span class="py-string">&lt;/table&gt;</span></span>
<a id="line69"></a><span class="lineno"> 69</span><span class="line"><span class="py-string">&quot;&quot;&quot;</span>%{<span class="py-string">'script'</span> : self.sxr_cgi})</span>
<a id="line70"></a><span class="lineno"> 70</span><span class="line">        self.end_file()</span>
<a id="line71"></a><span class="lineno"> 71</span>
<a id="line72"></a><span class="lineno"> 72</span><span class="line"><span class="py-keyword">class</span> <a href="../../../Scopes/Synopsis/Formatters/SXR/Formatter.html">Formatter</a>(Processor):</span>
<a id="line73"></a><span class="lineno"> 73</span><span class="line">    <span class="py-string">&quot;&quot;&quot;This is a facade to the HTML.Formatter. It adds an 'url' parameter and</span></span>
<a id="line74"></a><span class="lineno"> 74</span><span class="line"><span class="py-string">    dispatches it to various 'views'.&quot;&quot;&quot;</span></span>
<a id="line75"></a><span class="lineno"> 75</span>
<a id="line76"></a><span class="lineno"> 76</span><span class="line">    title = Parameter(<span class="py-string">'Synopsis - Cross-Reference'</span>, <span class="py-string">'title to put into html header'</span>)</span>
<a id="line77"></a><span class="lineno"> 77</span><span class="line">    url = Parameter(<span class="py-string">'/sxr.cgi'</span>, <span class="py-string">'the base url to use for the sxr cgi'</span>)</span>
<a id="line78"></a><span class="lineno"> 78</span><span class="line">    sxr_prefix = Parameter(None, <span class="py-string">'path prefix (directory) to contain sxr info'</span>)</span>
<a id="line79"></a><span class="lineno"> 79</span><span class="line">    src_dir = Parameter(<span class="py-string">''</span>, <span class="py-string">'starting point for directory listing'</span>)</span>
<a id="line80"></a><span class="lineno"> 80</span><span class="line">    exclude = Parameter([], <span class="py-string">'TODO: define an exclusion mechanism (glob based ?)'</span>)</span>
<a id="line81"></a><span class="lineno"> 81</span><span class="line">    sxr_template = Parameter(os.path.join(config.datadir, <span class="py-string">'sxr-template.html'</span>), <span class="py-string">'html template to be used by the sxr.cgi script'</span>)</span>
<a id="line82"></a><span class="lineno"> 82</span><span class="line">    stylesheet = Parameter(os.path.join(config.datadir, <span class="py-string">'html.css'</span>), <span class="py-string">'stylesheet to be used'</span>)</span>
<a id="line83"></a><span class="lineno"> 83</span>
<a id="line84"></a><span class="lineno"> 84</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/SXR/Formatter.html#process">process</a>(self, ir, **kwds):</span>
<a id="line85"></a><span class="lineno"> 85</span>
<a id="line86"></a><span class="lineno"> 86</span><span class="line">        self.set_parameters(kwds)</span>
<a id="line87"></a><span class="lineno"> 87</span><span class="line">        <span class="py-keyword">if</span> <span class="py-keyword">not</span> self.output: <span class="py-keyword">raise</span> MissingArgument(<span class="py-string">'output'</span>)</span>
<a id="line88"></a><span class="lineno"> 88</span><span class="line">        <span class="py-keyword">if</span> <span class="py-keyword">not</span> self.sxr_prefix: <span class="py-keyword">raise</span> MissingArgument(<span class="py-string">'sxr_prefix'</span>)</span>
<a id="line89"></a><span class="lineno"> 89</span>
<a id="line90"></a><span class="lineno"> 90</span><span class="line">        self.ir = self.merge_input(ir)</span>
<a id="line91"></a><span class="lineno"> 91</span>
<a id="line92"></a><span class="lineno"> 92</span><span class="line">        <span class="py-keyword">if</span> <span class="py-keyword">not</span> os.path.exists(self.output): os.makedirs(self.output)</span>
<a id="line93"></a><span class="lineno"> 93</span>
<a id="line94"></a><span class="lineno"> 94</span><span class="line">        content = [SXRIndex(sxr_cgi = self.url,</span>
<a id="line95"></a><span class="lineno"> 95</span><span class="line">                            template = Template(template = self.sxr_template)),</span>
<a id="line96"></a><span class="lineno"> 96</span><span class="line">                   Directory(src_dir = self.src_dir,</span>
<a id="line97"></a><span class="lineno"> 97</span><span class="line">                             base_path = self.src_dir,</span>
<a id="line98"></a><span class="lineno"> 98</span><span class="line">                             exclude = self.exclude,</span>
<a id="line99"></a><span class="lineno"> 99</span><span class="line">                             template = Template(template = self.sxr_template)),</span>
<a id="line100"></a><span class="lineno">100</span><span class="line">                   Source(external_url = <span class="py-string">'%s/ident?full=1&amp;string='</span>%self.url,</span>
<a id="line101"></a><span class="lineno">101</span><span class="line">                          template = Template(template = self.sxr_template)),</span>
<a id="line102"></a><span class="lineno">102</span><span class="line">                   RawFile(src_dir = self.src_dir,</span>
<a id="line103"></a><span class="lineno">103</span><span class="line">                           base_path = self.src_dir,</span>
<a id="line104"></a><span class="lineno">104</span><span class="line">                           exclude = self.exclude,</span>
<a id="line105"></a><span class="lineno">105</span><span class="line">                           template = Template(template = self.sxr_template))]</span>
<a id="line106"></a><span class="lineno">106</span>
<a id="line107"></a><span class="lineno">107</span><span class="line">        html = HTML.Formatter(index = [],</span>
<a id="line108"></a><span class="lineno">108</span><span class="line">                              detail = [],</span>
<a id="line109"></a><span class="lineno">109</span><span class="line">                              content = content,</span>
<a id="line110"></a><span class="lineno">110</span><span class="line">                              sxr_prefix = self.sxr_prefix,</span>
<a id="line111"></a><span class="lineno">111</span><span class="line">                              stylesheet = self.stylesheet)</span>
<a id="line112"></a><span class="lineno">112</span><span class="line">        self.ir = html.process(self.ir, output = self.output)</span>
<a id="line113"></a><span class="lineno">113</span>
<a id="line114"></a><span class="lineno">114</span><span class="line">        <span class="py-keyword">if</span> self.sxr_template:</span>
<a id="line115"></a><span class="lineno">115</span><span class="line">            copyfile(self.sxr_template,</span>
<a id="line116"></a><span class="lineno">116</span><span class="line">                     os.path.join(self.output, <span class="py-string">'sxr-template.html'</span>))</span>
<a id="line117"></a><span class="lineno">117</span>
<a id="line118"></a><span class="lineno">118</span><span class="line">        <span class="py-comment"># Store the SXR data only.</span></span>
<a id="line119"></a><span class="lineno">119</span><span class="line">        ir = IR.IR(sxr=self.ir.sxr)</span>
<a id="line120"></a><span class="lineno">120</span><span class="line">        ir.save(os.path.join(self.output, <span class="py-string">'sxr.syn'</span>))</span>
<a id="line121"></a><span class="lineno">121</span>
<a id="line122"></a><span class="lineno">122</span><span class="line">        <span class="py-keyword">return</span> self.ir</span>
<a id="line123"></a><span class="lineno">123</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:27:12 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
